<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

//////////////////
// Autorisation //
//////////////////

// Accès aux comptes administratifs connectés uniquement. Redirection pour les autres.
if ( $autorisation != 4 )  {
  header("Location: https://$site");
  exit();
}
$mysqli = connectsql();
// Si connexion light : on doit répéter son mot de passe pour aller plus loin
// login.php contient fin()
if ( $_SESSION['light'] )  {
  $titre = 'Relève des notes de colle';
  $actuel = 'relevenotes';
  include('login.php');
}

// Fonction pour l'affichage des durées en heures/minutes. Argument en minutes.
function format_duree($duree)  {
  if ( $duree == 0 )
    return '-';
  if ( $duree >= 60 )
    return intdiv($duree,60).'h'.( $duree%60 ?: '');
  return ($duree%60).'m';
}

//////////////////////////////////////
// Exportation des décomptes en xls //
//////////////////////////////////////
// Exportation uniquement si aucun header déjà envoyé
if ( isset($_REQUEST['decompte']) && ctype_digit($decompte = $_REQUEST['decompte']) && !headers_sent() )  {
  // Récupération de la bonne date et vérification
  $decompte = preg_replace('/(\d{2})(\d{2})(\d{2})/','20$1-$2-$3',$decompte);
  $resultat = $mysqli->query("SELECT IF(LENGTH(c.nom),CONCAT(c.nom,' ',c.prenom),c.login) AS colleur, m.nom AS matiere, SUM(nb) AS nb, SUM(duree) AS duree
                              FROM heurescolles AS h JOIN (SELECT COUNT(*) AS nb, heure FROM notes GROUP BY heure) AS n ON h.id = n.heure
                              JOIN utilisateurs AS c ON h.colleur = c.id JOIN matieres AS m ON h.matiere = m.id
                              WHERE h.releve = '$decompte' GROUP BY h.colleur ORDER BY c.nom, m.ordre");
  $mysqli->close();
  if ( $resultat->num_rows )  {
    // Fonctions de saisie
    function saisie_nombre($l, $c, $v)  {
      echo pack("sssss", 0x203, 14, $l, $c, 0).pack("d", $v);
      return;
    }
    function saisie_chaine($l, $c, $v)  {
      echo pack("ssssss", 0x204, 8 + strlen($v), $l, $c, 0, strlen($v)).$v;
      return;
    }
    // Envoi des headers
    header("Content-Type: application/vnd.ms-excel");
    header("Content-Disposition: attachment; filename=decompte-$decompte.xls");
    header("Content-Transfer-Encoding: binary");
    // Début du fichier xls
    echo pack("sssss", 0x809, 6, 0, 0x10, 0);
    // Remplissage
    saisie_chaine(0, 0, utf8_decode('Relevé des heures de colles - '.preg_replace('/(\d{4})-(\d{2})-(\d{2})/','$3/$2/$1',$decompte)));
    saisie_chaine(2, 0, 'Colleur');
    saisie_chaine(2, 1, utf8_decode('Matière'));
    saisie_chaine(2, 2, utf8_decode('Nombre d\'élèves'));
    saisie_chaine(2, 3, utf8_decode('Durée déclarée'));
    $i = 2;
    $total_n = 0;
    $total_duree = 0;
    while ( $r = $resultat->fetch_assoc() )  {
      saisie_chaine(++$i, 0, utf8_decode($r['colleur']));
      saisie_chaine($i, 1, utf8_decode($r['matiere']));
      saisie_nombre($i, 2, $r['nb']);
      saisie_chaine($i, 3, format_duree($r['duree']));
      $total_n += $r['nb'];
      $total_duree += $r['duree'];
    }
    // Totaux
    saisie_chaine($i = $i+2, 0, 'Total');
    saisie_nombre($i, 2, $total_n);
    saisie_chaine($i, 3, format_duree($total_duree));
    // Fin du fichier xls
    echo pack("ss", 0x0A, 0x00);
    $resultat->free();
    exit();
  }
}

//////////////////////////////////
// Exportation des notes en xls //
//////////////////////////////////
// Exportation uniquement si aucun header déjà envoyé
if ( isset($_REQUEST['notes']) && ctype_digit($decompte = $_REQUEST['notes']) && !headers_sent() )  {
  // Récupération de la bonne date et vérification
  $decompte = preg_replace('/(\d{2})(\d{2})(\d{2})/','20$1-$2-$3',$decompte);
  $resultat = $mysqli->query("SELECT h.id, IF(LENGTH(c.nom),CONCAT(c.nom,' ',c.prenom),c.login) AS colleur, IF(LENGTH(e.nom),CONCAT(e.nom,' ',e.prenom),e.login) AS eleve,
                              m.nom AS matiere, DATE_FORMAT(jour,'%d/%m/%y') AS jour, TIME_FORMAT(h.heure,'%kh%i') AS heure, note, duree
                              FROM notes AS n JOIN heurescolles AS h ON h.id = n.heure JOIN utilisateurs AS e ON n.eleve = e.id
                              JOIN utilisateurs AS c ON n.colleur = c.id JOIN matieres AS m ON n.matiere = m.id
                              WHERE h.releve = '$decompte' ORDER BY c.nom, h.jour, h.heure, e.nom");
  $mysqli->close();
  if ( $resultat->num_rows )  {
    // Fonctions de saisie
    function saisie_nombre($l, $c, $v)  {
      echo pack("sssss", 0x203, 14, $l, $c, 0).pack("d", $v);
      return;
    }
    function saisie_chaine($l, $c, $v)  {
      echo pack("ssssss", 0x204, 8 + strlen($v), $l, $c, 0, strlen($v)).$v;
      return;
    }
    // Envoi des headers
    header("Content-Type: application/vnd.ms-excel");
    header("Content-Disposition: attachment; filename=decompte-$decompte.xls");
    header("Content-Transfer-Encoding: binary");
    // Début du fichier xls
    echo pack("sssss", 0x809, 6, 0, 0x10, 0);
    // Remplissage
    saisie_chaine(0, 0, utf8_decode('Relevé des heures de colles - Détails des notes '.preg_replace('/(\d{4})-(\d{2})-(\d{2})/','$3/$2/$1',$decompte)));
    saisie_chaine(2, 0, 'Colleur');
    saisie_chaine(2, 1, utf8_decode('Matière'));
    saisie_chaine(2, 2, utf8_decode('Élève'));
    saisie_chaine(2, 3, utf8_decode('Note'));
    saisie_chaine(2, 4, utf8_decode('Date'));
    saisie_chaine(2, 5, utf8_decode('Heure'));
    saisie_chaine(2, 6, utf8_decode('Nb d\'élèves'));
    saisie_chaine(2, 7, utf8_decode('Durée déclarée'));
    $i = 2;
    $n = $hid = 0;
    while ( $r = $resultat->fetch_assoc() )  {
      if ( $hid != $r['id'] )  {
        if ( $n )  {
          for ( $j = 0 ; $j < $n ; $j++)
            saisie_nombre($i-$j, 6, $n);
        }
        $hid = $r['id'];
        $n = 0;
      }
      saisie_chaine(++$i, 0, utf8_decode($r['colleur']));
      saisie_chaine($i, 1, utf8_decode($r['matiere']));
      saisie_chaine($i, 2, utf8_decode($r['eleve']));
      saisie_chaine($i, 3, utf8_decode($r['note']));
      saisie_chaine($i, 4, utf8_decode($r['jour']));
      saisie_chaine($i, 5, utf8_decode($r['heure']));
      saisie_chaine($i, 7, format_duree($r['duree']));
      $n = $n+1;
    }
    for ( $j = 0 ; $j < $n ; $j++)
      saisie_nombre($i-$j, 6, $n);
    // Fin du fichier xls
    echo pack("ss", 0x0A, 0x00);
    $resultat->free();
    exit();
  }
}

//////////////
//// HTML ////
//////////////
debut($mysqli,'Relève des notes de colles',$message,4,'relevenotes');
echo <<<FIN

  <div id="icones">
    <a class="icon-voirtout" href="?tableau" title="Voir le tableau récapitulatif pour tous les colleurs"></a>
    <a class="icon-aide" title="Aide pour les relèves de notes de colles"></a>
  </div>

FIN;

// Si tableau récapitulatif total demandé
if ( isset($_REQUEST['tableau']) )  {
  $resultat = $mysqli->query('SELECT IF(LENGTH(c.nom),CONCAT(c.nom,\' \',c.prenom),c.login) AS colleur, m.nom AS matiere, 
                                     SUM(nb*(releve=0)) AS nbe_nr, SUM(duree*(releve=0)) AS duree_nr, 
                                     SUM(nb*(releve>0)) AS nbe_r, SUM(duree*(releve>0)) AS duree_r
                              FROM heurescolles AS h JOIN (SELECT COUNT(*) AS nb, heure FROM notes GROUP BY heure) AS n ON h.id = n.heure
                                     JOIN utilisateurs AS c ON h.colleur = c.id JOIN matieres AS m ON h.matiere = m.id
                              GROUP BY h.colleur ORDER BY m.ordre, c.nom');
  echo <<<FIN
  <article>
    <a class="icon-ferme" href="relevenotes" title="Fermer ce récapitulatif"></a>
    <h3>Récapitulatif annuel des heures de colles réalisées</h3>

FIN;
  if ( $resultat->num_rows )  {
    echo <<<FIN
    <table class="centre">
      <tbody>
        <tr><th colspan="2"></th><th colspan="2">Heures relevées</th><th colspan="2">Heures non relevées</th></tr>
        <tr><th>Matière</th><th>Colleur</th><th>Nombre d'élèves</th><th>Durée</th><th>Nombre d'élèves</th><th>Durée</th></tr>

FIN;
    while ( $r = $resultat->fetch_assoc() )
      echo "        <tr><td>${r['matiere']}</td><td>${r['colleur']}</td><td>${r['nbe_nr']}</td><td>".format_duree($r['duree_nr'])."</td><td>${r['nbe_r']}</td><td>".format_duree($r['duree_r'])."</td></tr>\n";
    echo "      </tbody>\n    </table>\n  </article>\n\n";
    $resultat->free();
  }
  else
    echo "<div class=\"annonce\">Il n'y a encore aucune heure de colle déclarée cette année.</div>\n  </article>\n\n";
}

// Récupération des heures à relever, matière par matière
$resultat = $mysqli->query('SELECT m.nom AS matiere, SUM(nb) AS nb, SUM(duree) AS duree
                            FROM heurescolles AS h JOIN (SELECT COUNT(*) AS nb, heure FROM notes GROUP BY heure) AS n ON h.id = n.heure JOIN matieres AS m ON h.matiere = m.id
                            WHERE h.releve = 0 GROUP BY h.matiere ORDER BY m.ordre');
echo "\n  <article>\n    <h3>Heures de colles à relever actuellement</h3>\n";
if ( $resultat->num_rows )  {
  echo <<<FIN
    <table class="centre">
      <tbody>
        <tr><th>Matière</th><th>Nombre d'élèves</th><th>Durée</th></tr>

FIN;
  while ( $r = $resultat->fetch_assoc() )  {
    echo "        <tr><td>${r['matiere']}</td><td>${r['nb']}</td><td>".format_duree($r['duree'])."</td></tr>\n";
  }
  echo <<<FIN
      </tbody>
    </table>
    <input id="relevenotes" type="button" class="ligne" value="Relever les notes">
  </article>

FIN;
  $resultat->free();
}
else
  echo "<div class=\"annonce\">Il n'y a actuellement aucune nouvelle heure de colle à relever.</div>\n  </article>\n\n";

// Récupération des relevés déjà réalisés
$resultat = $mysqli->query('SELECT DATE_FORMAT(releve,\'%d/%m/%y\') AS date, DATE_FORMAT(releve,\'%y%m%d\') AS ref, SUM(duree) AS duree, SUM(nb) AS nb
                            FROM heurescolles AS h JOIN (SELECT COUNT(*) AS nb, heure FROM notes GROUP BY heure) AS n ON h.id = n.heure
                            WHERE releve > 0 GROUP BY releve ORDER BY releve DESC');
echo "\n  <article>\n    <h3>Relevés déjà réalisés</h3>\n";
if ( $resultat->num_rows )  {
  echo <<<FIN
    <table class="centre">
      <tbody>
        <tr><th>Date</th><th>Décomptes des heures</th><th>Détail des notes</th></tr>

FIN;
  while ( $r = $resultat->fetch_assoc() )  {
    echo "        <tr><td>${r['date']}</td><td><a class=\"icon-download\" href=\"?decompte=${r['ref']}\"></a> ".format_duree($r['duree'])."</td><td><a class=\"icon-download\" href=\"?notes=${r['ref']}\"></a> ${r['nb']} notes</td></tr>\n";
  }
  echo "      </tbody>\n    </table>\n  </article>\n\n";
  $resultat->free();
}
else
  echo "<div class=\"annonce\">Vous n'avez pas encore réalisé de relevé cette année.</div>\n  </article>\n\n";
$mysqli->close();
?>

  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>Cette page n'est disponible que pour les utilisateurs de type administratif. Elle permet la relève des notes de colles saisies par les colleurs et les professeurs.</p>
    <p>Le bouton <em>Relever les notes</em> permet de réaliser une relève des notes de colles. Cela consiste à marquer comme relevées toutes les heures déclarées jusqu'à maintenant et non encore relevées. Une confirmation sera demandée. Toutes les colles non encore relevées le seront alors&nbsp;: il n'est pas possible de sélectionner seulement une période.</p>
    <p>L'ensemble des relevés est consigné dans un tableau. Y sont téléchargeables&nbsp;:
    <ul>
      <li>le décompte des heures, suffisant pour mettre au paiement les heures de colles</li>
      <li>le détail de l'ensemble des notes, si besoin de vérification</li>
    </ul> 
    </p>
    <p>Le bouton général <span class="icon-voirtout"></span> permet de visualiser un tableau récapitulatif global des totaux dans toutes les matières, depuis le début de l'année.</p>
    <h4>Du côté des colleurs</h4>
    <p>Les colleurs et professeurs ne peuvent plus modifier la durée ni le nombre d'élèves notés pendant les colles marquées comme relevées. Ils peuvent cependant encore modifier les notes, y compris pour les élèves «&nbsp;non notés&nbsp;» ou «&nbsp;absents&nbsp;».</p>
    <p>Les colleurs ont accès à la liste de leur colles et des dates de relèves. Ils sont donc au courant des heures qui doivent être mises au paiment.</p>
    <p>Les professeurs ont accès aux totaux du nombre d'élèves et du nombre d'heures qui ont été déclarées, relevées et non relevées. Cela leur permet de voir si un colleur déclare un nombre d'heures suspect.</p>
    <h4>Retards de déclaration</h4>
    <p>Le retard de déclaration d'un colleur est sans conséquence&nbsp;: à chaque relève, les colles non encore relevées le sont, indépendemment des dates des relèves précédentes. Il n'y a pas de régularisation globale à prévoir en juin.</p>
    <h4></h4>
    <h4>Binômes, élèves absents</h4>
    <p>Les textes officiels sont parfaitement clairs&nbsp;: l'heure de colle est indivisible, un binôme doit être payé une heure, au moins pour les matières où une heure est la durée réelle de la colle. C'est pour cela que la durée déclarée par les colleurs peut différer du simple produit nombre d'élèves par durée individuelle. Cela dépend cependant du budget global. Le plus sain est d'avoir débattu le sujet avec l'équipe pédagogique.</p>
    <p>Les élèves absents doivent rattraper leur colle. À défaut, le colleur doit quand même être payé&nbsp;: c'est pour cela qu'il n'y a pas de différence entre un élève noté et un élève absent dans le décompte.</p>
  </div>

  <p id="log"></p>

<?php
fin(true);
?>
