<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

//////////////////
// Autorisation //
//////////////////

// Accès aux professeurs, colleurs, élèves connectés uniquement
$mysqli = connectsql();
if ( !$autorisation )  {
  $titre = 'Préférences';
  $actuel = false;
  include('login.php');
}
elseif ( $autorisation < 2 )  {
  debut($mysqli,'Préférences','Vous n\'avez pas accès à cette page.',$autorisation,' ');
  $mysqli->close();
  fin();
}
// Si connexion light : on doit répéter son mot de passe pour aller plus loin
// login.php contient fin()
if ( $_SESSION['light'] )  {
  $titre = 'Mon compte';
  $actuel = 'prefs';
  include('login.php');
}

//////////////
//// HTML ////
//////////////
debut($mysqli,'Mon compte',$message,$autorisation,'prefs');

// Récupération des données de l'utilisateur
$resultat = $mysqli->query("SELECT login, nom, prenom, mail, mdp, timeout, mailexp,
                            IF(mailcopie,' checked','') AS mailcopie,
                            IF(mailenvoi,' checked','') AS mailenvoi,
                            IF(mailliste,' checked','') AS mailliste,
                            IF(permconn > '',' checked','') AS permconn
                            FROM utilisateurs WHERE id = ${_SESSION['id']}");
$mysqli->close();
$r = $resultat->fetch_assoc();
$resultat->free();
?>

  <div id="icones">
    <a class="icon-aide" title="Aide pour les modifications de vos préférences"></a>
  </div>

  <article>
    <a class="icon-ferme" title="Fermer ce cadre"></a>
    <h3>Confidentialité des données</h3>
    <p>Les données stockées dans ce Cahier de Prépa à propos de vous sont modifiables ici. Il ne s'agit que de données permettant le fonctionnement de ce site. Aucune de ces données ne sera jamais partagée avec une autre entité.</p>
    <p>Votre mot de passe vous est complètement personnel. Il est chiffré avant son stockage dans la base de données et ne peut donc techniquement être divulgué à personne.</p>
    <p>Ces données (excepté votre mot de passe) sont aussi accessibles et modifiables par l'ensemble des professeurs de la classe pour permettre le bon fonctionnement du site. Par votre inscription sur ce site, vous autorisez cela et l'administrateur du site à stocker ces informations. Les éventuelles notes de colles que vous pouvez avoir ne sont consultables que par les pages dédiées, pour chaque matière.</p>
    <p>Pour supprimer votre compte, vous devez le demander aux professeurs de la classe.</p>
    <p>Le mot de passe associé à votre compte doit être obligatoirement fourni pour toute modification sur cette page. Cela permet d'être sûr que la modification n'est pas réalisée par quelqu'un d'autre.</p>
    <p>D'autres données de connexion sont stockées pour le service du site&nbsp;: les connexions aux comptes (avec identifiant et adresse IP) et les modifications de la base de données sont consignées pour réparer les éventuelles erreurs. Ces données sont supprimées en fin d'année scolaire. Ces données ne sont exploitées qu'en cas de besoin technique et ne sont pas partagées.</p>
  </article>

  <article data-id="prefsperso|1">
    <h3 class="edition">Mon identité</h3>
    <a class="icon-ok noreload" title="Valider les modifications"></a>
    <form>
      <p class="ligne"><label for="prenom">Prénom&nbsp;: </label><input type="text" id="prenom" name="prenom" value="<?php echo $r['prenom']; ?>" size="50"></p>
      <p class="ligne"><label for="nom">Nom&nbsp;: </label><input type="text" id="nom" name="nom" value="<?php echo $r['nom']; ?>" size="50"></p>
      <p class="ligne"><label for="mail1">Adresse électronique&nbsp;: </label><input type="email" id="mail1" name="mail1" value="<?php echo $r['mail']; ?>" size="50"></p>
      <p class="ligne"><label for="mail2">Confirmation&nbsp;: </label><input type="email" id="mail2" name="mail2" value="" size="50"></p>
      <p class="ligne"><label for="mdp_1">Mot de passe&nbsp;: </label><input type="password" id="mdp_1" name="mdp" value=""></p>
      <p>Le mot de passe actuel doit être obligatoirement fourni pour toute modification.</p>
    </form>
  </article>

  <article data-id="prefsperso|2">
    <h3 class="edition">Mon mot de passe</h3>
    <a class="icon-ok noreload" title="Valider les modifications"></a>
    <form>
      <p class="ligne"><label for="mdp_2">Mot de passe actuel&nbsp;: </label><input type="password" id="mdp_2" name="mdp" value=""></p>
      <p class="ligne"><label for="mdp1">Nouveau mot de passe&nbsp;: </label><input type="password" id="mdp1" name="mdp1" value=""></p>
      <p class="ligne"><label for="mdp2">Confirmation&nbsp;: </label><input type="password" id="mdp2" name="mdp2" value=""></p>
    </form>
  </article>

  <article data-id="prefsperso|3">
    <h3 class="edition">Ma connexion</h3>
    <a class="icon-ok noreload" title="Valider les modifications"></a>
    <form>
      <p class="ligne"><label for="login">Identifiant&nbsp;: </label><input type="text" id="login" name="login" value="<?php echo $r['login']; ?>" size="50"></p>
      <p class="ligne"><label for="permconn">Conserver ma connexion sur cette machine&nbsp;: </label><input type="checkbox" id="permconn" name="permconn" value="1"<?php echo $r['permconn']; ?>></p>
      <p class="ligne"><label for="timeout">Durée avant déconnexion&nbsp;: </label><input type="text" id="timeout" name="timeout" value="<?php echo $r['timeout']; ?>" size="3"></p>
      <p class="ligne"><label for="mdp_3">Mot de passe actuel&nbsp;: </label><input type="password" id="mdp_3" name="mdp" value=""></p>
      <p>Le mot de passe actuel doit être obligatoirement fourni pour toute modification.</p>
    </form>
  </article>
<?php
// Cas d'envoi de mail des élèves : uniquement si validé par un professeur
if ( ( $autorisation == 2 ) && $_SESSION['mailenvoi'] )  {
?>

  <article data-id="prefsperso|4">
    <h3 class="edition">Mes envois de courriel</h3>
    <a class="icon-ok noreload" title="Valider les modifications"></a>
    <form>
      <p class="ligne"><label for="mailexp">Nom d'expéditeur&nbsp;: </label><input type="text" id="mailexp" name="mailexp" value="<?php echo $r['mailexp']; ?>" size="50"></p>
      <p class="ligne"><label for="mailcopie">Recevoir une copie des courriels envoyés&nbsp;: </label><input type="checkbox" id="mailcopie" name="mailcopie" value="1"<?php echo $r['mailcopie']; ?>></p>
      <p class="ligne"><label for="mdp_4">Mot de passe actuel&nbsp;: </label><input type="password" id="mdp_4" name="mdp" value=""></p>
      <p>Le mot de passe actuel doit être obligatoirement fourni pour toute modification.</p>
    </form>
  </article>
<?php
}
// Cas des comptes colleur/administration/professeur
elseif ( $autorisation > 2 )  {
?>

  <article data-id="prefsperso|4">
    <h3 class="edition">Mes envois de courriel</h3>
    <a class="icon-ok noreload" title="Valider les modifications"></a>
    <form>
      <p class="ligne"><label for="mailenvoi">S'autoriser l'envoi de courriel&nbsp;: </label><input type="checkbox" id="mailenvoi" name="mailenvoi" value="1"<?php echo $r['mailenvoi']; ?>></p>
      <p class="ligne"><label for="mailexp">Nom d'expéditeur&nbsp;: </label><input type="text" id="mailexp" name="mailexp" value="<?php echo $r['mailexp']; ?>" size="50"></p>
      <p class="ligne"><label for="mailcopie">Recevoir une copie des courriels envoyés&nbsp;: </label><input type="checkbox" id="mailcopie" name="mailcopie" value="1"<?php echo $r['mailcopie']; ?>></p>
      <p class="ligne"><label for="mailliste">Apparaître dans la liste visible des élèves&nbsp;: </label><input type="checkbox" id="mailliste" name="mailliste" value="1"<?php echo $r['mailliste']; ?>></p>
      <p class="ligne"><label for="mdp_4">Mot de passe actuel&nbsp;: </label><input type="password" id="mdp_4" name="mdp" value=""></p>
      <p>Le mot de passe actuel doit être obligatoirement fourni pour toute modification.</p>
    </form>
  </article>
<?php
}
?>

  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>Il est possible ici de modifier vos préférences. Une fois modifié, un formulaire est à validé par un clic sur le bouton <span class="icon-ok"></span>.</p>
    <p>Afin d'éviter les usurpations de compte, il est nécessaire de taper son mot de passe pour toute modification.</p>
    <h4>Modification de l'identité&nbsp;: nom, prénom, adresse électronique</h4>
    <p>Si l'on souhaite modifier l'adresse électronique, il faut la saisir deux fois afin d'éviter les fautes de frappes.</p>
    <p>Afin d'éviter les usurpations de compte, il est nécessaire de taper son mot de passe pour toute modification.</p>
    <p>L'adresse électronique ne sera pas modifiée si un autre compte contient déjà la nouvelle valeur saisie.</p>
    <p>Il est possible de ne modifier que le prénom ou le nom sans modifier l'adresse électronique&nbsp;: il n'est alors pas nécessaire de saisir une deuxième fois l'adresse électronique.</p>
    <p>L'adresse électronique peut servir pour envoyer ou recevoir des courriels, en fonction du réglage choisi par l'équipe pédagogique.</p>
    <h4>Modification des paramètres de connexion</h4>
    <p>Votre identifiant est initialement de la forme &laquo;&nbsp;jdupont&nbsp;&raquo;. Vous pouvez le modifier, à condition de ne pas demander un identifiant déjà existant dans la base.</p>
    <p>La <em>durée avant connexion</em> est la durée en secondes au bout de laquelle votre session sera effacée sur le serveur, et une reconnexion sera nécessaire. C'est une sécurité si vous oubliez de vous déconnecter alors que vous êtes sur un ordinateur ouvert au public. La valeur par défaut est 900s, soit 15 minutes.</p>
    <p>La case à cocher <em>Conserver ma connexion sur cette machine</em> est au contraire utile lorsque vous êtes sur une machine personnelle, comme votre téléphone. Cocher cette case permet de ne pas avoir besoin de se connecter systématiquement. Le mot de passe ne sera demandé que pour l'affichage de données nomminatives ou de modifications importantes.</p>
  </div>

  <p id="log"></p>
  
  <script type="text/javascript">
$( function() {
  // Envoi par appui sur Entrée
  $('input').on('keypress',function (e) {
    if ( e.which == 13 ) {
      $(this).parents('article').children('a.icon-ok').click();
      return false;
    }
  });
  $('.icon-ferme').on('click',function() {
    $(this).parent().remove();
  });
});
  </script>
<?php
fin(true);
?>
